//+------------------------------------------------------------------+
//|                                              ATR slope histo.mq4 |
//|                                              brax64              |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "brax64"
#property link      "http://www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  Green
#property indicator_color2  Red
#property indicator_color3  Gold

//---- input parameters

extern int    periods    = 10;

int    limit, i, counted_bars;
double atr[], up[], down[], neutral[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,up);      SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,down);    SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,neutral); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,atr);     SetIndexStyle(3,DRAW_NONE);

   return(0);
}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+

int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
{
   counted_bars = IndicatorCounted(); 
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
   limit = Bars - counted_bars;
   
   for (i = 0; i < limit; i++)
   {
      atr[i] = iATR(Symbol(), 0, periods, i);
   }
   
   for (i = 0; i < limit; i++)
   {   
      if(atr[i] <  atr[i+1])
      {
         down[i]    = atr[i];
         neutral[i] = EMPTY_VALUE;
         up[i]      = EMPTY_VALUE;
      }
      if(atr[i] == atr[i+1])
      {
         neutral[i] = atr[i];
         up[i]      = EMPTY_VALUE;
         down[i]    = EMPTY_VALUE;
      }
      if(atr[i] >  atr[i+1])
      {
         up[i]      = atr[i];
         down[i]    = EMPTY_VALUE;
         neutral[i] = EMPTY_VALUE;
      }
   }
       
   
   return(0);
}